﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Axle3Client
{
	public partial class AxlePanel : UserControl
	{
		public AxlePanel()
		{
			InitializeComponent();

			DoubleBuffered = true;
		}

		private int offsetX = 0;

		public int OffsetX
		{
			get { return offsetX; }
			set { offsetX = value; }
		}
		private int offsetY = 0;

		public int OffsetY
		{
			get { return offsetY; }
			set { offsetY = value; }
		}
		private int offsetZ = 0;

		public int OffsetZ
		{
			get { return offsetZ; }
			set { offsetZ = value; }
		}

		protected override void OnPaint(PaintEventArgs e)
		{
			Graphics g = e.Graphics;
			for (int x = 0; x < ClientSize.Width; x += 30)
			{
				for (int y = 0; y < ClientSize.Height; y += 30)
				{
					g.DrawLine(Pens.DimGray, 0, y, ClientSize.Width, y);
				}
				g.DrawLine(Pens.DimGray, x, 0, x, ClientSize.Height);
			}

			g.DrawString("X=" + offsetX + ", Y=" + offsetY + ", Z=" + offsetZ, Font,
				Brushes.Lime, 10, 10);

			int cx = ClientSize.Width/2 - offsetX;
			int cy = ClientSize.Height/2 - offsetY;

			g.DrawEllipse(Pens.Lime, cx - 20, cy - 20, 40, 40);
		}

		protected override void OnResize(EventArgs e)
		{
			base.OnResize(e);
			Invalidate();
		}
	}
}
