﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.IO.Ports;

namespace Axle3Client
{
	public partial class Form1 : Form
	{
		private Thread inputThread;

		public Form1()
		{
			InitializeComponent();
		}

		private void Form1_Load(object sender, EventArgs e)
		{
			inputThread = new Thread(ReadInput);
			inputThread.Start();
		}

		private int avgx = 0;
		private int avgy = 0;
		private int avgz = 0;

		void ReadInput()
		{
			SerialPort sp = new SerialPort("COM23");
			try
			{
				sp.Open();

				while (inputThread.IsAlive)
				{
					string line = sp.ReadLine();
					string[] splitted = line.Split(',');
					if (splitted.Length > 2)
					{
						int x = int.Parse(splitted[0]);
						int y = int.Parse(splitted[1]);
						int z = int.Parse(splitted[2]);

						if (avgx == 0 && avgy == 0)
						{
							avgx = -x;
							avgy = y;
							avgz = z;
						}

						axlePanel1.OffsetX += (avgx + x) /2;
						axlePanel1.OffsetY += (avgy - y) /2;
						axlePanel1.OffsetZ += (avgz - z) /2;

						Thread.Sleep(50);
						axlePanel1.Invalidate(false);

					}
				}

				sp.Close();
			}
			catch (Exception ex)
			{
				MessageBox.Show("Error: " + ex.Message);
			}
		}

		protected override void OnClosing(CancelEventArgs e)
		{
			inputThread.Abort();
			base.OnClosing(e);
		}

		private void axlePanel1_MouseDown(object sender, MouseEventArgs e)
		{
			avgx = 0;
			avgy = 0;
			axlePanel1.OffsetX = 0;
			axlePanel1.OffsetY = 0;
		}
	}
}
